//
//  KochView.m
//  ScrollView
//
//  Created by Clemens Wagner on 05.02.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "KochView.h"
#import "KochLayer.h"
#import "Demo.h"

@implementation KochView

+ (id)layerClass {
    return [KochLayer class];
}

- (KochLayer *)kochLayer {
    return (KochLayer *)self.layer;
}

- (CGFloat)depth {
    return [self.kochLayer depth];
}

- (void)setDepth:(CGFloat)inDepth {
    [self.kochLayer setDepth:inDepth];
}

#if DEMO == 3

- (id<CAAction>)actionForLayer:(CALayer *)inLayer forKey:(NSString *)inKey {
    if([inKey isEqualToString:@"depth"]) {
        CABasicAnimation *theAnimation = [CABasicAnimation animation];

        theAnimation.fromValue = @(self.depth);
        theAnimation.duration = [CATransaction animationDuration];
        theAnimation.timingFunction = [CATransaction animationTimingFunction];
        return theAnimation;
    }
    else {
        return [super actionForLayer:inLayer forKey:inKey];
    }
}

#endif

@end
